diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/mgt-action-headers.h ns-3.42/src/wifi/model/mgt-action-headers.h
--- ns-3.41/src/wifi/model/mgt-action-headers.h	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/mgt-action-headers.h	2024-05-29 15:29:47.204074000 -0700
@@ -22,7 +22,11 @@
 #ifndef MGT_ACTION_HEADERS_H
 #define MGT_ACTION_HEADERS_H
 
+#include "reduced-neighbor-report.h"
 #include "status-code.h"
+#include "tim.h"
+#include "wifi-opt-field.h"
+#include "wifi-standards.h"
 
 #include "ns3/header.h"
 
@@ -99,6 +103,7 @@
     {
         QAB_REQUEST = 16,
         QAB_RESPONSE = 17,
+        FILS_DISCOVERY = 34
     };
 
     /// RadioMeasurementActionValue enumeration
@@ -666,6 +671,175 @@
     std::optional<EmlsrParamUpdate> m_emlsrParamUpdate{}; //!< EMLSR Parameter Update field
 };
 
+/**
+ * \ingroup wifi
+ * Implement the FILS (Fast Initial Link Setup) action frame.
+ * See sec. 9.6.7.36 of IEEE 802.11-2020 and IEEE 802.11ax-2021.
+ */
+class FilsDiscHeader : public Header
+{
+  public:
+    FilsDiscHeader();
+
+    /// \return the object TypeId
+    static TypeId GetTypeId();
+    TypeId GetInstanceTypeId() const override;
+    void Print(std::ostream& os) const override;
+    uint32_t GetSerializedSize() const override;
+    void Serialize(Buffer::Iterator start) const override;
+    uint32_t Deserialize(Buffer::Iterator start) override;
+
+    /**
+     * Set the SSID field.
+     *
+     * \param ssid the SSID
+     */
+    void SetSsid(const std::string& ssid);
+
+    /// \return the SSID
+    const std::string& GetSsid() const;
+
+    /// \return size of FILS Discovery Information field in octets
+    uint32_t GetInformationFieldSize() const;
+
+    /// \return size of non-optional subfields in octets
+    uint32_t GetSizeNonOptSubfields() const;
+
+    /// \brief sets value of Length subfield
+    void SetLengthSubfield();
+
+    /// FILS Discovery Frame Control subfield of FILS Discovery Information field
+    struct FilsDiscFrameControl // 2 octets
+    {
+        uint8_t m_ssidLen : 5 {0};               ///< SSID Length
+        bool m_capPresenceInd{false};            ///< Capability Presence Indicator
+        uint8_t m_shortSsidInd : 1 {0};          ///< Short SSID Indicator (not supported)
+        bool m_apCsnPresenceInd{false};          ///< AP-CSN Presence Indicator
+        bool m_anoPresenceInd{false};            ///< ANO Presence Indicator
+        bool m_chCntrFreqSeg1PresenceInd{false}; ///< Channel Center Frequency Segment 1
+                                                 ///< Presence Indicator
+        bool m_primChPresenceInd{false};         ///< Primary Channel Presence Indicator
+        uint8_t m_rsnInfoPresenceInd : 1 {0};    ///< RSN info Presence Indicator (not supported)
+        bool m_lenPresenceInd{false};            ///< Length Presence Indicator
+        uint8_t m_mdPresenceInd : 1 {0};         ///< MD Presence Indicator (not supported)
+        uint8_t m_reserved : 2 {0};              ///< Reserved Bits
+
+        /**
+         * \brief serialize content to a given buffer
+         * \param start given input buffer iterator
+         */
+        void Serialize(Buffer::Iterator& start) const;
+
+        /**
+         * \brief read content from a given buffer
+         * \param start input buffer iterator
+         * \return number of read octets
+         */
+        uint32_t Deserialize(Buffer::Iterator start);
+    };
+
+    /// FD Capability subfield of FILS Discovery Information field
+    struct FdCapability // 2 octets
+    {
+        uint8_t m_ess : 1 {0};                   ///< ESS
+        uint8_t m_privacy : 1 {0};               ///< Privacy
+        uint8_t m_chWidth : 3 {0};               ///< BSS Operating Channel Width
+        uint8_t m_maxNss : 3 {0};                ///< Maximum Number of Spatial Streams
+        uint8_t m_reserved : 1 {0};              ///< Reserved Bit
+        uint8_t m_multiBssidPresenceInd : 1 {0}; ///< Multiple BSSIDs Presence Indicator
+        uint8_t m_phyIdx : 3 {0};                ///< PHY Index
+        uint8_t m_minRate : 3 {0};               ///< FILS Minimum Rate
+
+        /**
+         * \brief Set the BSS Operating Channel Width field based on the operating channel width
+         * \param width the operating channel width in MHz
+         */
+        void SetOpChannelWidth(uint16_t width);
+
+        /// \return the operating channel width encoded in the BSS Operating Channel Width field
+        uint16_t GetOpChannelWidth() const;
+
+        /**
+         * \brief Set the Maximum Number of Spatial Streams field
+         * \param maxNss the maximum number of supported spatial streams
+         */
+        void SetMaxNss(uint8_t maxNss);
+
+        /**
+         * Note that this function returns 5 if the maximum number of supported spatial streams
+         * is greater than 4.
+         *
+         * \return the maximum number of supported spatial streams
+         */
+        uint8_t GetMaxNss() const;
+
+        /**
+         * \brief Set the PHY Index field based on the given wifi standard
+         * \param standard the wifi standard
+         */
+        void SetStandard(WifiStandard standard);
+
+        /**
+         * \param band the PHY band in which the device is operating (needed to distinguish
+         *             between 802.11a and 802.11g)
+         * \return the wifi standard encoded in the PHY Index field
+         */
+        WifiStandard GetStandard(WifiPhyBand band) const;
+
+        /**
+         * \brief serialize content to a given buffer
+         * \param start given input buffer iterator
+         */
+        void Serialize(Buffer::Iterator& start) const;
+
+        /**
+         * \brief read content from a given buffer
+         * \param start input buffer iterator
+         * \return number of read octets
+         */
+        uint32_t Deserialize(Buffer::Iterator start);
+    };
+
+    // FILS Discovery Frame Information field
+    // TODO: add optional FD-RSN and Mobility domain subfields
+    FilsDiscFrameControl m_frameCtl;               ///< FILS Discovery Frame Control
+    uint64_t m_timeStamp{0};                       ///< Timestamp
+    uint16_t m_beaconInt{0};                       ///< Beacon Interval in TU (1024 us)
+    OptFieldWithPresenceInd<uint8_t> m_len;        ///< Length
+    OptFieldWithPresenceInd<FdCapability> m_fdCap; ///< FD Capability
+    std::optional<uint8_t> m_opClass;              ///< Operating Class
+    OptFieldWithPresenceInd<uint8_t> m_primaryCh;  ///< Primary Channel
+    OptFieldWithPresenceInd<uint8_t>
+        m_apConfigSeqNum;                            ///< AP Configuration Sequence Number (AP-CSN)
+    OptFieldWithPresenceInd<uint8_t> m_accessNetOpt; ///< Access Network Options
+    OptFieldWithPresenceInd<uint8_t> m_chCntrFreqSeg1; ///< Channel Center Frequency Segment 1
+
+    // (Optional) Information Elements
+    std::optional<ReducedNeighborReport> m_rnr; ///< Reduced Neighbor Report
+    std::optional<Tim> m_tim;                   ///< Traffic Indication Map element
+
+  private:
+    std::string m_ssid; ///< SSID
+};
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the output stream
+ * \param control the Fils Discovery Frame Control field
+ * \returns a reference to the stream
+ */
+std::ostream& operator<<(std::ostream& os, const FilsDiscHeader::FilsDiscFrameControl& control);
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the output stream
+ * \param capability the Fils Discovery Frame Capability field
+ * \returns a reference to the stream
+ */
+std::ostream& operator<<(std::ostream& os, const FilsDiscHeader::FdCapability& capability);
+
 } // namespace ns3
 
 #endif /* MGT_ACTION_HEADERS_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/mgt-headers.h ns-3.42/src/wifi/model/mgt-headers.h
--- ns-3.41/src/wifi/model/mgt-headers.h	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/mgt-headers.h	2024-05-29 15:29:47.204074000 -0700
@@ -35,6 +35,7 @@
 #include "ns3/eht-capabilities.h"
 #include "ns3/eht-operation.h"
 #include "ns3/erp-information.h"
+#include "ns3/he-6ghz-band-capabilities.h"
 #include "ns3/he-capabilities.h"
 #include "ns3/he-operation.h"
 #include "ns3/ht-capabilities.h"
@@ -96,6 +97,7 @@
                                      std::optional<ExtendedCapabilities>,
                                      std::optional<VhtCapabilities>,
                                      std::optional<HeCapabilities>,
+                                     std::optional<He6GhzBandCapabilities>,
                                      std::optional<EhtCapabilities>>;
 
 /// List of Information Elements included in Probe Response frames
@@ -114,6 +116,7 @@
                                       std::optional<HeCapabilities>,
                                       std::optional<HeOperation>,
                                       std::optional<MuEdcaParameterSet>,
+                                      std::optional<He6GhzBandCapabilities>,
                                       std::optional<MultiLinkElement>,
                                       std::optional<EhtCapabilities>,
                                       std::optional<EhtOperation>,
@@ -127,6 +130,7 @@
                                      std::optional<ExtendedCapabilities>,
                                      std::optional<VhtCapabilities>,
                                      std::optional<HeCapabilities>,
+                                     std::optional<He6GhzBandCapabilities>,
                                      std::optional<MultiLinkElement>,
                                      std::optional<EhtCapabilities>,
                                      std::vector<TidToLinkMapping>>;
@@ -143,6 +147,7 @@
                                       std::optional<HeCapabilities>,
                                       std::optional<HeOperation>,
                                       std::optional<MuEdcaParameterSet>,
+                                      std::optional<He6GhzBandCapabilities>,
                                       std::optional<MultiLinkElement>,
                                       std::optional<EhtCapabilities>,
                                       std::optional<EhtOperation>,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/mpdu-aggregator.cc ns-3.42/src/wifi/model/mpdu-aggregator.cc
--- ns-3.41/src/wifi/model/mpdu-aggregator.cc	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/mpdu-aggregator.cc	2024-05-29 15:29:47.204074000 -0700
@@ -150,6 +150,7 @@
     // Retrieve the Capabilities elements advertised by the recipient
     auto ehtCapabilities = stationManager->GetStationEhtCapabilities(recipient);
     auto heCapabilities = stationManager->GetStationHeCapabilities(recipient);
+    auto he6GhzCapabilities = stationManager->GetStationHe6GhzCapabilities(recipient);
     auto vhtCapabilities = stationManager->GetStationVhtCapabilities(recipient);
     auto htCapabilities = stationManager->GetStationHtCapabilities(recipient);
 
@@ -166,6 +167,10 @@
         NS_ABORT_MSG_IF(!heCapabilities, "HE Capabilities element not received");
 
         maxAmpduSize = std::min(maxAmpduSize, heCapabilities->GetMaxAmpduLength());
+        if (he6GhzCapabilities)
+        {
+            maxAmpduSize = std::min(maxAmpduSize, he6GhzCapabilities->GetMaxAmpduLength());
+        }
     }
     else if (modulation == WIFI_MOD_CLASS_VHT)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/msdu-aggregator.cc ns-3.42/src/wifi/model/msdu-aggregator.cc
--- ns-3.41/src/wifi/model/msdu-aggregator.cc	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/msdu-aggregator.cc	2024-05-29 15:29:47.204074000 -0700
@@ -187,6 +187,7 @@
 
     // Retrieve the Capabilities elements advertised by the recipient
     auto ehtCapabilities = stationManager->GetStationEhtCapabilities(recipient);
+    auto he6GhzCapabilities = stationManager->GetStationHe6GhzCapabilities(recipient);
     auto vhtCapabilities = stationManager->GetStationVhtCapabilities(recipient);
     auto htCapabilities = stationManager->GetStationHtCapabilities(recipient);
 
@@ -199,12 +200,16 @@
     {
         maxMpduSize = ehtCapabilities->GetMaxMpduLength();
     }
+    else if (he6GhzCapabilities && m_mac->Is6GhzBand(m_linkId))
+    {
+        maxMpduSize = he6GhzCapabilities->GetMaxMpduLength();
+    }
     else if (vhtCapabilities && m_mac->GetWifiPhy(m_linkId)->GetPhyBand() != WIFI_PHY_BAND_2_4GHZ)
     {
         maxMpduSize = vhtCapabilities->GetMaxMpduLength();
     }
 
-    if (!htCapabilities)
+    if (!htCapabilities && !he6GhzCapabilities)
     {
         /* "A non-DMG STA shall not transmit an A-MSDU to a STA from which it has
          * not received a frame containing an HT Capabilities element" (Section
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/non-ht/dsss-error-rate-model.cc ns-3.42/src/wifi/model/non-ht/dsss-error-rate-model.cc
--- ns-3.41/src/wifi/model/non-ht/dsss-error-rate-model.cc	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/non-ht/dsss-error-rate-model.cc	2024-05-29 15:29:47.204074000 -0700
@@ -44,8 +44,8 @@
 DsssErrorRateModel::DqpskFunction(double x)
 {
     NS_LOG_FUNCTION_NOARGS();
-    return ((std::sqrt(2.0) + 1.0) / std::sqrt(8.0 * M_PI * std::sqrt(2.0))) *
-           (1.0 / std::sqrt(x)) * std::exp(-(2.0 - std::sqrt(2.0)) * x);
+    return ((M_SQRT2 + 1.0) / std::sqrt(8.0 * M_PI * M_SQRT2)) * (1.0 / std::sqrt(x)) *
+           std::exp(-(2.0 - M_SQRT2) * x);
 }
 
 double
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/non-ht/dsss-phy.cc ns-3.42/src/wifi/model/non-ht/dsss-phy.cc
--- ns-3.41/src/wifi/model/non-ht/dsss-phy.cc	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/non-ht/dsss-phy.cc	2024-05-29 15:29:47.204074000 -0700
@@ -32,6 +32,9 @@
 
 #include <array>
 
+#undef NS_LOG_APPEND_CONTEXT
+#define NS_LOG_APPEND_CONTEXT WIFI_PHY_NS_LOG_APPEND_CONTEXT(m_wifiPhy)
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/non-ht/erp-ofdm-phy.cc ns-3.42/src/wifi/model/non-ht/erp-ofdm-phy.cc
--- ns-3.41/src/wifi/model/non-ht/erp-ofdm-phy.cc	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/non-ht/erp-ofdm-phy.cc	2024-05-29 15:29:47.204074000 -0700
@@ -30,6 +30,9 @@
 
 #include <array>
 
+#undef NS_LOG_APPEND_CONTEXT
+#define NS_LOG_APPEND_CONTEXT WIFI_PHY_NS_LOG_APPEND_CONTEXT(m_wifiPhy)
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/non-ht/ofdm-phy.cc ns-3.42/src/wifi/model/non-ht/ofdm-phy.cc
--- ns-3.41/src/wifi/model/non-ht/ofdm-phy.cc	2024-02-09 14:44:08.589794900 -0800
+++ ns-3.42/src/wifi/model/non-ht/ofdm-phy.cc	2024-05-29 15:29:47.204074000 -0700
@@ -32,6 +32,9 @@
 
 #include <array>
 
+#undef NS_LOG_APPEND_CONTEXT
+#define NS_LOG_APPEND_CONTEXT WIFI_PHY_NS_LOG_APPEND_CONTEXT(m_wifiPhy)
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/phy-entity.cc ns-3.42/src/wifi/model/phy-entity.cc
--- ns-3.41/src/wifi/model/phy-entity.cc	2024-02-09 14:44:08.593795000 -0800
+++ ns-3.42/src/wifi/model/phy-entity.cc	2024-05-29 15:29:47.204074000 -0700
@@ -37,6 +37,9 @@
 
 #include <algorithm>
 
+#undef NS_LOG_APPEND_CONTEXT
+#define NS_LOG_APPEND_CONTEXT WIFI_PHY_NS_LOG_APPEND_CONTEXT(m_wifiPhy)
+
 namespace ns3
 {
 
@@ -158,7 +161,7 @@
 WifiPpduField
 PhyEntity::GetNextField(WifiPpduField currentField, WifiPreamble preamble) const
 {
-    auto ppduFormats = GetPpduFormats();
+    const auto& ppduFormats = GetPpduFormats();
     const auto itPpdu = ppduFormats.find(preamble);
     if (itPpdu != ppduFormats.end())
     {
@@ -337,7 +340,7 @@
                     NanoSeconds(0)); // this callback (equivalent to PHY-RXSTART primitive) is also
                                      // triggered for filtered PPDUs
             }
-            m_wifiPhy->NotifyRxDrop(GetAddressedPsduInPpdu(ppdu), status.reason);
+            m_wifiPhy->NotifyRxPpduDrop(ppdu, status.reason);
             m_wifiPhy->NotifyCcaBusy(ppdu, GetRemainingDurationAfterField(ppdu, field));
         // no break
         case IGNORE:
@@ -368,7 +371,7 @@
     NS_LOG_FUNCTION(this << field << *event);
     NS_ASSERT(field != WIFI_PPDU_FIELD_PREAMBLE &&
               field != WIFI_PPDU_FIELD_DATA); // handled apart for the time being
-    auto ppduFormats = GetPpduFormats();
+    const auto& ppduFormats = GetPpduFormats();
     auto itFormat = ppduFormats.find(event->GetPpdu()->GetPreamble());
     if (itFormat != ppduFormats.end())
     {
@@ -515,7 +518,7 @@
 PhyEntity::DropPreambleEvent(Ptr<const WifiPpdu> ppdu, WifiPhyRxfailureReason reason, Time endRx)
 {
     NS_LOG_FUNCTION(this << ppdu << reason << endRx);
-    m_wifiPhy->NotifyRxDrop(GetAddressedPsduInPpdu(ppdu), reason);
+    m_wifiPhy->NotifyRxPpduDrop(ppdu, reason);
     auto it = m_wifiPhy->m_currentPreambleEvents.find({ppdu->GetUid(), ppdu->GetPreamble()});
     if (it != m_wifiPhy->m_currentPreambleEvents.end())
     {
@@ -738,6 +741,7 @@
         success = false;
     }
 
+    m_state->NotifyRxPpduOutcome(ppdu, rxSignalInfo, txVector, staId, statusPerMpduIt->second);
     DoEndReceivePayload(ppdu);
     m_wifiPhy->SwitchMaybeToCcaBusy(ppdu);
 
@@ -871,7 +875,11 @@
                                    RxPowerWattPerChannelBand& rxPower,
                                    bool isStartHePortionRxing /* = false */)
 {
-    return m_wifiPhy->m_interference->Add(ppdu, duration, rxPower, isStartHePortionRxing);
+    return m_wifiPhy->m_interference->Add(ppdu,
+                                          duration,
+                                          rxPower,
+                                          m_wifiPhy->GetCurrentFrequencyRange(),
+                                          isStartHePortionRxing);
 }
 
 void
@@ -887,7 +895,7 @@
         // interference
         event = CreateInterferenceEvent(ppdu, ppdu->GetTxDuration(), rxPower);
         NS_LOG_DEBUG("Drop PPDU that arrived too late");
-        m_wifiPhy->NotifyRxDrop(GetAddressedPsduInPpdu(ppdu), PPDU_TOO_LATE);
+        m_wifiPhy->NotifyRxPpduDrop(ppdu, PPDU_TOO_LATE);
         return;
     }
 
@@ -938,8 +946,9 @@
 {
     NS_LOG_FUNCTION(this << *event);
     NS_LOG_DEBUG("Sync to signal (power=" << WToDbm(GetRxPowerWForPpdu(event)) << "dBm)");
-    m_wifiPhy->m_interference
-        ->NotifyRxStart(); // We need to notify it now so that it starts recording events
+    m_wifiPhy->m_interference->NotifyRxStart(
+        m_wifiPhy->GetCurrentFrequencyRange()); // We need to notify it now so that it starts
+                                                // recording events
     m_endPreambleDetectionEvents.push_back(
         Simulator::Schedule(m_wifiPhy->GetPreambleDetectionDuration(),
                             &PhyEntity::EndPreambleDetectionPeriod,
@@ -979,7 +988,8 @@
                      << maxEvent->GetPpdu()->GetUid()
                      << " during preamble detection: drop packet with UID "
                      << event->GetPpdu()->GetUid());
-        m_wifiPhy->NotifyRxDrop(GetAddressedPsduInPpdu(event->GetPpdu()), BUSY_DECODING_PREAMBLE);
+        m_wifiPhy->NotifyRxPpduDrop(event->GetPpdu(), BUSY_DECODING_PREAMBLE);
+
         auto it = m_wifiPhy->m_currentPreambleEvents.find(
             {event->GetPpdu()->GetUid(), event->GetPpdu()->GetPreamble()});
         m_wifiPhy->m_currentPreambleEvents.erase(it);
@@ -988,7 +998,7 @@
         m_wifiPhy->m_interference->NotifyRxEnd(maxEvent->GetStartTime(),
                                                m_wifiPhy->GetCurrentFrequencyRange());
         // Make sure InterferenceHelper keeps recording events
-        m_wifiPhy->m_interference->NotifyRxStart();
+        m_wifiPhy->m_interference->NotifyRxStart(m_wifiPhy->GetCurrentFrequencyRange());
         return;
     }
 
@@ -1035,7 +1045,8 @@
                 {
                     reason = BUSY_DECODING_PREAMBLE;
                 }
-                m_wifiPhy->NotifyRxDrop(GetAddressedPsduInPpdu(it->second->GetPpdu()), reason);
+                m_wifiPhy->NotifyRxPpduDrop(it->second->GetPpdu(), reason);
+
                 it = m_wifiPhy->m_currentPreambleEvents.erase(it);
             }
             else
@@ -1045,7 +1056,7 @@
         }
 
         // Make sure InterferenceHelper keeps recording events
-        m_wifiPhy->m_interference->NotifyRxStart();
+        m_wifiPhy->m_interference->NotifyRxStart(m_wifiPhy->GetCurrentFrequencyRange());
 
         m_wifiPhy->NotifyRxBegin(GetAddressedPsduInPpdu(m_wifiPhy->m_currentEvent->GetPpdu()),
                                  m_wifiPhy->m_currentEvent->GetRxPowerWPerBand());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/qos-frame-exchange-manager.cc ns-3.42/src/wifi/model/qos-frame-exchange-manager.cc
--- ns-3.41/src/wifi/model/qos-frame-exchange-manager.cc	2024-02-09 14:44:08.593795000 -0800
+++ ns-3.42/src/wifi/model/qos-frame-exchange-manager.cc	2024-05-29 15:29:47.204074000 -0700
@@ -27,7 +27,7 @@
 #include "ns3/log.h"
 
 #undef NS_LOG_APPEND_CONTEXT
-#define NS_LOG_APPEND_CONTEXT std::clog << "[link=" << +m_linkId << "][mac=" << m_self << "] "
+#define NS_LOG_APPEND_CONTEXT WIFI_FEM_NS_LOG_APPEND_CONTEXT
 
 namespace ns3
 {
@@ -149,7 +149,7 @@
 QosFrameExchangeManager::CancelPifsRecovery()
 {
     NS_LOG_FUNCTION(this);
-    NS_ASSERT(m_pifsRecoveryEvent.IsRunning());
+    NS_ASSERT(m_pifsRecoveryEvent.IsPending());
     NS_ASSERT(m_edca);
 
     NS_LOG_DEBUG("Cancel PIFS recovery being attempted by EDCAF " << m_edca);
@@ -162,7 +162,7 @@
 {
     NS_LOG_FUNCTION(this << edca << allowedWidth);
 
-    if (m_pifsRecoveryEvent.IsRunning())
+    if (m_pifsRecoveryEvent.IsPending())
     {
         // Another AC (having AIFS=1 or lower, if the user changed the default settings)
         // gained channel access while performing PIFS recovery. Abort PIFS recovery
@@ -186,7 +186,7 @@
 {
     NS_LOG_FUNCTION(this << edca << txopDuration);
 
-    if (m_pifsRecoveryEvent.IsRunning())
+    if (m_pifsRecoveryEvent.IsPending())
     {
         // Another AC (having AIFS=1 or lower, if the user changed the default settings)
         // gained channel access while performing PIFS recovery. Abort PIFS recovery
@@ -311,6 +311,8 @@
     {
         WifiTxParameters fragmentTxParams;
         fragmentTxParams.m_txVector = txParams.m_txVector;
+        fragmentTxParams.AddMpdu(item);
+        UpdateTxDuration(item->GetHeader().GetAddr1(), fragmentTxParams);
         txParams.m_protection = GetProtectionManager()->TryAddMpdu(item, fragmentTxParams);
         NS_ASSERT(txParams.m_protection);
     }
@@ -334,8 +336,13 @@
     NS_ASSERT(mpdu);
     NS_LOG_FUNCTION(this << *mpdu << &txParams << availableTime);
 
+    // tentatively add the given MPDU
+    auto prevTxDuration = txParams.m_txDuration;
+    txParams.AddMpdu(mpdu);
+    UpdateTxDuration(mpdu->GetHeader().GetAddr1(), txParams);
+
     // check if adding the given MPDU requires a different protection method
-    Time protectionTime = Time::Min(); // uninitialized
+    std::optional<Time> protectionTime; // uninitialized
     if (txParams.m_protection)
     {
         protectionTime = txParams.m_protection->protectionTime;
@@ -355,11 +362,11 @@
         txParams.m_protection.swap(protection);
         protectionSwapped = true;
     }
-    NS_ASSERT(protectionTime != Time::Min());
-    NS_LOG_DEBUG("protection time=" << protectionTime);
+    NS_ASSERT(protectionTime.has_value());
+    NS_LOG_DEBUG("protection time=" << *protectionTime);
 
     // check if adding the given MPDU requires a different acknowledgment method
-    Time acknowledgmentTime = Time::Min(); // uninitialized
+    std::optional<Time> acknowledgmentTime; // uninitialized
     if (txParams.m_acknowledgment)
     {
         acknowledgmentTime = txParams.m_acknowledgment->acknowledgmentTime;
@@ -379,19 +386,21 @@
         txParams.m_acknowledgment.swap(acknowledgment);
         acknowledgmentSwapped = true;
     }
-    NS_ASSERT(acknowledgmentTime != Time::Min());
-    NS_LOG_DEBUG("acknowledgment time=" << acknowledgmentTime);
+    NS_ASSERT(acknowledgmentTime.has_value());
+    NS_LOG_DEBUG("acknowledgment time=" << *acknowledgmentTime);
 
     Time ppduDurationLimit = Time::Min();
     if (availableTime != Time::Min())
     {
-        ppduDurationLimit = availableTime - protectionTime - acknowledgmentTime;
+        ppduDurationLimit = availableTime - *protectionTime - *acknowledgmentTime;
     }
 
     if (!IsWithinLimitsIfAddMpdu(mpdu, txParams, ppduDurationLimit))
     {
-        // adding MPDU failed, restore protection and acknowledgment methods
-        // if they were swapped
+        // adding MPDU failed, undo the addition of the MPDU and restore protection and
+        // acknowledgment methods if they were swapped
+        txParams.UndoAddMpdu();
+        txParams.m_txDuration = prevTxDuration;
         if (protectionSwapped)
         {
             txParams.m_protection.swap(protection);
@@ -403,10 +412,6 @@
         return false;
     }
 
-    // the given MPDU can be added, hence update the txParams
-    txParams.AddMpdu(mpdu);
-    UpdateTxDuration(mpdu->GetHeader().GetAddr1(), txParams);
-
     return true;
 }
 
@@ -449,7 +454,8 @@
     // Get the maximum PPDU Duration based on the preamble type
     Time maxPpduDuration = GetPpduMaxTime(txParams.m_txVector.GetPreambleType());
 
-    Time txTime = GetTxDuration(ppduPayloadSize, receiver, txParams);
+    NS_ASSERT_MSG(txParams.m_txDuration, "TX duration not yet computed");
+    auto txTime = txParams.m_txDuration.value();
     NS_LOG_DEBUG("PPDU duration: " << txTime.As(Time::MS));
 
     if ((ppduDurationLimit.IsStrictlyPositive() && txTime > ppduDurationLimit) ||
@@ -483,7 +489,7 @@
     }
 
     NS_ASSERT(txParams.m_acknowledgment &&
-              txParams.m_acknowledgment->acknowledgmentTime != Time::Min());
+              txParams.m_acknowledgment->acknowledgmentTime.has_value());
 
     // under multiple protection settings, if the TXOP limit is not null, Duration/ID
     // is set to cover the remaining TXOP time (Sec. 9.2.5.2 of 802.11-2016).
@@ -491,7 +497,7 @@
     // of 802.11-2016)
     return std::max(m_edca->GetRemainingTxop(m_linkId) -
                         m_phy->CalculateTxDuration(size, txParams.m_txVector, m_phy->GetPhyBand()),
-                    txParams.m_acknowledgment->acknowledgmentTime);
+                    *txParams.m_acknowledgment->acknowledgmentTime);
 }
 
 Time
@@ -635,7 +641,7 @@
             // we can continue the TXOP if the carrier sense mechanism indicates that
             // the medium is idle in a PIFS
             NS_LOG_DEBUG("TX of a non-initial frame of a TXOP failed: perform PIFS recovery");
-            NS_ASSERT(!m_pifsRecoveryEvent.IsRunning());
+            NS_ASSERT(!m_pifsRecoveryEvent.IsPending());
             m_pifsRecoveryEvent =
                 Simulator::Schedule(m_phy->GetPifs(), &QosFrameExchangeManager::PifsRecovery, this);
         }
@@ -698,22 +704,31 @@
 QosFrameExchangeManager::SetTxopHolder(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this << psdu << txVector);
+    if (auto txopHolder = FindTxopHolder(psdu->GetHeader(0), txVector))
+    {
+        m_txopHolder = *txopHolder;
+    }
+}
 
-    const WifiMacHeader& hdr = psdu->GetHeader(0);
+std::optional<Mac48Address>
+QosFrameExchangeManager::FindTxopHolder(const WifiMacHeader& hdr, const WifiTxVector& txVector)
+{
+    NS_LOG_FUNCTION(this << hdr << txVector);
 
     // A STA shall save the TXOP holder address for the BSS in which it is associated.
     // The TXOP holder address is the MAC address from the Address 2 field of the frame
     // that initiated a frame exchange sequence, except if this is a CTS frame, in which
     // case the TXOP holder address is the Address 1 field. (Sec. 10.23.2.4 of 802.11-2020)
-    if ((hdr.IsQosData() || hdr.IsMgt() || hdr.IsRts()) &&
+    if ((hdr.IsQosData() || hdr.IsMgt() || hdr.IsRts() || hdr.IsBlockAckReq()) &&
         (hdr.GetAddr1() == m_bssid || hdr.GetAddr2() == m_bssid))
     {
-        m_txopHolder = psdu->GetAddr2();
+        return hdr.GetAddr2();
     }
-    else if (hdr.IsCts() && hdr.GetAddr1() == m_bssid)
+    if (hdr.IsCts() && hdr.GetAddr1() == m_bssid)
     {
-        m_txopHolder = psdu->GetAddr1();
+        return hdr.GetAddr1();
     }
+    return std::nullopt;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/qos-frame-exchange-manager.h ns-3.42/src/wifi/model/qos-frame-exchange-manager.h
--- ns-3.41/src/wifi/model/qos-frame-exchange-manager.h	2024-02-09 14:44:08.593795000 -0800
+++ ns-3.42/src/wifi/model/qos-frame-exchange-manager.h	2024-05-29 15:29:47.204074000 -0700
@@ -171,12 +171,14 @@
     virtual bool SendCfEndIfNeeded();
 
     /**
-     * Set the TXOP holder, if needed, based on the received frame
+     * Determine the holder of the TXOP, if possible, based on the received frame
      *
-     * \param psdu the received PSDU
+     * \param hdr the MAC header of an MPDU included in the received PSDU
      * \param txVector TX vector of the received PSDU
+     * \return the holder of the TXOP, if one was found
      */
-    virtual void SetTxopHolder(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector);
+    virtual std::optional<Mac48Address> FindTxopHolder(const WifiMacHeader& hdr,
+                                                       const WifiTxVector& txVector);
 
     /**
      * Clear the TXOP holder if the NAV counted down to zero (includes the case of NAV reset).
@@ -190,6 +192,14 @@
 
   private:
     /**
+     * Set the TXOP holder, if needed, based on the received frame
+     *
+     * \param psdu the received PSDU
+     * \param txVector TX vector of the received PSDU
+     */
+    void SetTxopHolder(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector);
+
+    /**
      * Cancel the PIFS recovery event and have the EDCAF attempting PIFS recovery
      * release the channel.
      */
